function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { BizGlobalDataContext } from '@zgfe/business-lib';
import { Switch } from 'antd';
import React, { useContext, useState } from 'react';
import apis from '../../../../constants/api';
import ZModulesCDP from '../../../../types';
import request from '@zgfe/business-lib/es/utils/ajax';
var FusionSwitch = function FusionSwitch(props) {
  var task = props.task;
  var _useState = useState(task.status === ZModulesCDP.DataSet.TaskStatus.enable),
    _useState2 = _slicedToArray(_useState, 2),
    enable = _useState2[0],
    setEnable = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    loading = _useState4[0],
    setLoading = _useState4[1];
  var _useContext = useContext(BizGlobalDataContext),
    currentApp = _useContext.currentApp,
    authority = _useContext.authority;
  function onChange() {
    var status = !enable;
    setLoading(true);
    request(apis.updateJobStatus, {
      method: 'post',
      data: {
        id: task.id,
        enable: status,
        appId: currentApp === null || currentApp === void 0 ? void 0 : currentApp.appId
      },
      errorTitle: '操作失败'
    }).then(function (res) {
      if (!res) throw new Error();
      setEnable(status);
      if (props.onChange) props.onChange(status ? ZModulesCDP.DataSet.TaskStatus.enable : ZModulesCDP.DataSet.TaskStatus.disable);
    }).catch(function (err) {
      console.error('修改任务状态失败', err);
    }).finally(function () {
      setLoading(false);
    });
  }
  return /*#__PURE__*/React.createElement(Switch, {
    disabled: !authority[1706261691] || task.state === ZModulesCDP.DataSet.UpdateState.running,
    checkedChildren: "\u542F\u7528",
    unCheckedChildren: "\u7981\u7528",
    checked: enable,
    loading: loading,
    onClick: onChange
  });
};
export default FusionSwitch;